"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
/**
 * An image asset that has to be loaded from a URI
 */

/**
 * An image asset that is loaded from a require('path/to/file') call
 */

/**
 * A source for the image loader
 */

/**
 * Fallback image asset(s)
 */

/**
 * A barebones image loader component that can handle falling back to backup images when the primary image fails to load
 */
const Image = props => {
  const {
    // After spending a few hours trying to get this to work, I'm giving up
    // As a workaround, I'm casting the `Image` component to `any`
    // TODO: Fix this typing
    component: CustomComponent = _reactNative.Image,
    source,
    fallback,
    onError,
    ...rest
  } = props;
  const [currentSource, setCurrentSource] = (0, _react.useState)(source);
  const [sourceIndex, setSourceIndex] = (0, _react.useState)(0);

  // Start with the source prop
  // And reset the index when the source or fallback changes
  (0, _react.useEffect)(() => {
    setCurrentSource(source);
    setSourceIndex(0);
  }, [source, fallback]);
  const handleError = error => {
    // If we have more sources to try, move to the next one
    const nextIndex = sourceIndex + 1;

    // The logic can never go back to the source prop on an onError event
    // It can only move forward to a fallback
    // So, we can safely assume that the nextIndex will always be greater than 0
    // We are using this logic to resolve the next fallback source
    const fallbacks = Array.isArray(fallback) ? fallback : [fallback];
    const nextSource = fallbacks[nextIndex - 1]; // Subtracting 1 to compensate for the source item

    if (nextSource) {
      setSourceIndex(nextIndex);
      setCurrentSource(nextSource);
    } else {
      // The sources have been exhausted
      // Call the onError callback if provided
      onError?.(error);
    }
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(CustomComponent, {
    source: currentSource,
    onError: handleError,
    ...rest
  });
};
var _default = exports.default = Image;
//# sourceMappingURL=Image.js.map